## portmap-5.tar.bz2

=== Makefile ===
# @(#) Makefile 1.6 96/07/06 23:06:17

####################################
### Beginning of configurable stuff.

# By default, logfile entries are written to the same file as used for
# sendmail transaction logs. Change the definition of the following macro
# if you disagree. See `man 3 syslog' for examples. Some syslog versions
# do not provide this flexibility.
#
FACILITY=LOG_DAEMON

# To disable tcp-wrapper style access control, comment out the following
# macro definitions.  Access control can also be turned off by providing
# no access control tables. The local system, since it runs the portmap
# daemon, is always treated as an authorized host.

HOSTS_ACCESS= -DHOSTS_ACCESS
#WRAP_LIB = $(WRAP_DIR)/libwrap.a
WRAP_LIB = -lwrap

# Comment out if your RPC library does not allocate privileged ports for
# requests from processes with root privilege, or the new portmap will
# always reject requests to register/unregister services on privileged
# ports. You can find out by running "rpcinfo -p"; if all mountd and NIS
# daemons use a port >= 1024 you should probably disable the next line.

CHECK_PORT = -DCHECK_PORT

# Warning: troublesome feature ahead!! Enable only when you are really
# desperate!!
#
# It is possible to prevent an attacker from manipulating your portmapper
# tables from outside with requests that contain spoofed source addresses.
# The countermeasure is to force all rpc servers to register and
# unregister with the portmapper via the loopback network interface,
# instead of via the primary network interface that every host can talk
# to. For this countermeasure to work it is necessary to uncomment the
# LOOPBACK definition below, and to take the following additional steps:
# 
# (1) Modify the libc library (or librpc if you have one) and replace
# get_myaddress() by a version that selects the loopback address instead
# of the primary network interface address. A suitable version is
# provided in the file get_myaddress.c. This forces rpc servers to send
# all set/unset requests to the loopback address.
# 
# (2) Rebuild all statically-linked rpc servers with the modified
# library.
# 
# (3) Disable IP source routing in the kernel (otherwise an outside
# attacker can still send requests that appear to come from the local
# machine).
# 
# Instead of (1) it may be sufficient to run the rpc servers with a
# preload shared object that implements the alternate get_myaddress()
# behavior (see Makefile.shlib). You still need to disable IP source
# routing, though.
#
# I warned you, you need to be really desperate to do this. It is
# probably much easier to just block port UDP and TCP ports 111 on
# your routers.
#
# LOOPBACK = -DLOOPBACK_SETUNSET

# When the portmapper cannot find any local interfaces (it will complain
# to the syslog daemon) your system probably has variable-length socket
# address structures (struct sockaddr has a sa_len component; examples:
# AIX 4.1 and 4.4BSD). Uncomment next macro definition in that case.
#
# SA_LEN = -DHAS_SA_LEN		# AIX 4.x, BSD 4.4, FreeBSD, NetBSD

# With verbose logging on, HP-UX 9.x and AIX 4.1 leave zombies behind when
# SIGCHLD is not ignored. Enable next macro for a fix.
#
ZOMBIES = -DIGNORE_SIGCHLD	# AIX 4.x, HP-UX 9.x

# Under heavy I/O, sometimes portmap dies w/ SIGPIPE.  Enable next macro to
# fix.
#
BROKEN_PIPE = -DIGNORE_SIGPIPE

# Uncomment the following macro if your system does not have u_long.
#
# ULONG	=-Du_long="unsigned long"

# Later versions of the tcp wrapper (log_tcp package) come with a
# libwrap.a object library. WRAP_DIR should specify the directory with
# that library.

WRAP_DIR= $(TCPD_DIR)

# Auxiliary object files that may be missing from your C library.
#
#AUX	= daemon.o strerror.o

# glibc has strerror() (it's POSIX) and daemon() (when compiling -D_BSD_SOURCE)
AUX	= 

# NEXTSTEP is a little different. The following seems to work with NS 3.2
#
# SETPGRP	=-DUSE_SETPGRP00
# LIBS	= -m
# NSARCHS	= -arch m68k -arch i386 -arch hppa

# Auxiliary libraries that you may have to specify
#
# LIBS	= -lrpc

# Comment out if your compiler talks ANSI and understands const
#
#CONST   = -Dconst=

### End of configurable stuff.
##############################

GLIBC=$(shell grep -s -c __GLIBC__ /usr/include/features.h)

ifeq ($(GLIBC),0)
LIBS   += # -lbsd
else
LIBS   += -lnsl
endif


SHELL	= /bin/sh

COPT	= $(CONST) $(HOSTS_ACCESS) $(CHECK_PORT) \
	$(SYS) -DFACILITY=$(FACILITY) $(ULONG) $(ZOMBIES) $(BROKEN_PIPE) \
	$(SA_LEN) $(LOOPBACK) $(SETPGRP)
CFLAGS	= -Wall $(COPT) -O2 $(NSARCHS)
OBJECTS	= portmap.o pmap_check.o from_local.o $(AUX)

all:	portmap pmap_dump pmap_set

portmap: $(OBJECTS) # $(WRAP_DIR)/libwrap.a
	$(CC) $(CFLAGS) -o $@ $(OBJECTS) $(WRAP_LIB) $(LIBS)

pmap_dump: pmap_dump.c
	$(CC) $(CFLAGS) -o $@ $? $(LIBS)

pmap_set: pmap_set.c
	$(CC) $(CFLAGS) -o $@ $? $(LIBS)

from_local: from_local.c
	cc $(CFLAGS) -DTEST -o $@ from_local.c

get_myaddress: get_myaddress.c
	cc $(CFLAGS) -DTEST -o $@ get_myaddress.c $(LIBS)

install: all
	install -o root -g root -m 0755 -s portmap ${BASEDIR}/sbin
	install -o root -g root -m 0755 -s pmap_dump ${BASEDIR}/sbin
	install -o root -g root -m 0755 -s pmap_set ${BASEDIR}/sbin
	install -o root -g root -m 0644 portmap.8 ${BASEDIR}/usr/share/man/man8
	install -o root -g root -m 0644 pmap_dump.8 ${BASEDIR}/usr/share/man/man8
	install -o root -g root -m 0644 pmap_set.8 ${BASEDIR}/usr/share/man/man8
	cat BLURB >${BASEDIR}/usr/share/doc/portmap/portmapper.txt
	gzip -9f ${BASEDIR}/usr/share/doc/portmap/portmapper.txt


lint:	
	lint $(COPT) $(OBJECTS:%.o=%.c)

clean:
	rm -f *.o portmap pmap_dump pmap_set from_local get_myaddress \
	    get_myaddress.so core

tidy:	clean
	chmod 755 . ; chmod -R a+r .

deps:
	@$(CC) -M $(CFLAGS) *.c | grep -v /usr/include |sed 's/\.\///'

daemon.o: daemon.c
from_local.o: from_local.c
get_myaddress.o: get_myaddress.c
pmap_check.o: pmap_check.c
pmap_check.o: pmap_check.h Makefile
pmap_dump.o: pmap_dump.c
pmap_set.o: pmap_set.c
portmap.o: portmap.c
portmap.o: pmap_check.h Makefile
strerror.o: strerror.c

=== debian/changelog ===
portmap (5-26) unstable; urgency=low

  * Really fix the encoding issues in the Spanish debconf translation
    (there was still one char in latin1)
  [ New translations ]
  * Basque po-debconf translation, provided by Piarres Beobide 
  (Closes: #404178)
  * Portuguese translation, provided by Miguel Figueiredo (Closes: #404552)
  * Galician translation, provided by Jacobo Tarrio (Closes: #405401)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Sun, 11 Feb 2007 17:31:24 +0100

portmap (5-25) unstable; urgency=low

  * Fixed encoding in Spanish manpage, thanks to Christian Perrier for
    spotting this and providing a patch (Closes: #404166)
  [ Translation updates ]
  * Spanish po-debconf review by Javier Fernandez-Sanguino.
  * Brazilian Portuguese update by André Luís Lopes (Closes: #403826)
  * Swedish updated by Daniel Nylander.
  * Vietnamese updated by Clytie Siddall.

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Fri, 22 Dec 2006 09:16:14 +0100

portmap (5-24) unstable; urgency=medium

  * Fixed "subprocess post-installation script returned error exit
    status 1". Closes: #402220.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 10 Dec 2006 11:50:26 +1100

portmap (5-23) unstable; urgency=low

  * Adapt patch from Ubuntu to prevent rpcinfo from being executed if
    portmap is not running for some reason. This prevents this script
    from stalling in some installations (was reported at Ubuntu
    Malone bug #61668: Building LTSP chroot stops during portmap installation)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Thu,  7 Dec 2006 11:21:20 +0100

portmap (5-22) unstable; urgency=low

  * Add German debconf translation provided by Mathias Klein (Closes: #397043)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Thu,  7 Dec 2006 10:19:30 +0100

portmap (5-21) unstable; urgency=low

  * Add a note in the manpage related to the use of IP addresses in
    /etc/hosts.{allow,deny} when protecting portmapper. (Closes: #361019)
  * Updated translations:
    - Spanish translation update provided by Javier Fernandez-Sanguino 
      (Closes: #382962)
    - Japanese translation update provided by Kenshi Muto (Closes: #379933)
  [ debian/postinst ]
  * Modify postinst so it does not run 'rpcinfo -p' for new installs of the
    package as suggested by Joey Hess, this solves a problem with new d-i
    installations since rpcinfo stalls when the package is being installed, a
    static IP address has been assigned, 'lo' is down and portmap tries
    to list the RPC services available. (Closes: #383941)
  [ debian/rules ]
  * Re-add the 'start' sentences in runlevels 2-5 (revert the change
    introduced in -17 and reopens #340158, #334758). This is needed because if
    someone goes to runlevel 1 (stops portmapper and NFS) and then back to
    runlevel 2 portmapper would not start and NFS would fail. 
  [ debian/init.d ]
  * Reorder the "Starting portmap" message so it is presented before we say
    "Already running"

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Wed, 11 Oct 2006 12:12:10 +0200

portmap (5-20) unstable; urgency=low

  * Resynchronise with Ubuntu.
  * Set Standards-Version to 3.7.2.
  * Set DH_COMPAT to 5.
  * Dutch Debconf templates translation, closes: #367961.
    Patch by Vincent Zweije <zweije@xs4all.nl>.
  * Russian debconf templates translation, closes: #374007.
    Patch by Alexander Bouksha <abook@purpe.ru>.
  * Fixed "typo in postinst script", closes: #357248.
  * Fixed "unused function in postinst", closes: #376120.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 09 Jul 2006 20:23:16 +1000

portmap (5-19ubuntu2) edgy; urgency=low

  * Source debconf confmodule at top of postinst.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 30 Jun 2006 18:39:11 +0100

portmap (5-19ubuntu1) edgy; urgency=low

  * Sync with Debian.

 -- Tollef Fog Heen <tfheen@ubuntu.com>  Fri, 30 Jun 2006 13:18:57 +0200

portmap (5-19) unstable; urgency=low

  * Remove duplicate LSB info and fix the stop argument in runlevel 1
    (Closes: #361053)
  * Translation updates:
    - Dutch, provided by Vincent Zweije (Closes: #356278)
    - Danish, provided by Claus Hindsgaul (Closes: #357425)
    - Italian, provided by Luca Monducci (Closes: #357583)
    - Czech, provided by Miroslav Kure (Closes: #360314)
    - French, provided by Jean-Christophe Champarnaud (Closes: #360629)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Tue, 25 Apr 2006 00:55:41 +0200

portmap (5-18) unstable; urgency=low

  * Use the LSB init.d script provided by Ubuntu
  * Rephrase the template to make it clear that only those *not* providing RPC
    services to the network should bind only to loopback (#316607)
  * Included patch provided by Gerrit Pape which adds an '-f' option to make
    it work in foreground mode (Closes: #351625)

 -- Javier Fernandez-Sanguino Pen~a <jfs@computer.org>  Sat, 25 Feb 2006 23:13:07 +0100

portmap (5-17) unstable; urgency=low

  * Fixed "Portmap dies w/ SIGPIPE during heavy I/O", closes: #342709.
    Patch by Michael S. Peek <peek@tiem.utk.edu>.
  * Fixed "init script needlessly executed twice (and it informs the
    user about it too)", closes: #340158, #334758. Patch by Joey Hess
    <joeyh@debian.org>.
  * Added Swedish debconf translation, closes: #333125. Patch by
    Daniel Nylander <yeager@lidkoping.net>.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Tue, 17 Jan 2006 08:59:01 +1100

portmap (5-16ubuntu2) dapper; urgency=low

  * Actually exit 0 if the portmap is already running.  Malone #6717

 -- Tollef Fog Heen <tfheen@ubuntu.com>  Fri, 13 Jan 2006 09:24:49 +0100

portmap (5-16ubuntu1) dapper; urgency=low

  * Resynchronise with Debian.

 -- Tollef Fog Heen <tfheen@ubuntu.com>  Thu,  1 Dec 2005 14:00:51 +0100

portmap (5-16) unstable; urgency=low

  * Fixed "Speed up the boot by not sleeping in init.d/portmap
    twice", closes: #326100. Patch by Petter Reinholdtsen
    <pere@hungry.com>.


=== debian/control ===
Source: portmap
Section: net
Priority: standard
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Uploaders: Javier Fernandez-Sanguino Pen~a <jfs@computer.org>
Standards-Version: 3.7.2
Build-Depends: libwrap-dev, debhelper (>= 5)

Package: portmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 1.3-9)
Replaces: netbase (<< 4.00)
Description: The RPC portmapper
 Portmap is a server that converts RPC (Remote Procedure Call) program
 numbers into DARPA protocol port numbers.  It must be running in order
 to make RPC calls.
 .
 Services that use RPC include NFS and NIS.
